# -*- coding: utf-8 -*-
from cherrypy_mako import *
from mako_mail import *
from models.user import *
import userinfo

class Register_View(object):
	@cherrypy.expose
	def index(self, name = None, email = None \
		, comment = None, password1 = None, password2= None \
		, submitting=None):
		if not name:
			return serve_template("register.html", submit=False)
		# Server side validation
		if not validateUsername(name):
			return "Invalid username"		
		if not email:
			return "Email is missing"
		if not password1:
			return "Password is missing"            
		if not validateEmail(email):            
			return "Invalid email"
			
		if User.query.filter_by(username = name).first():
			return serve_template("register.html" \
				, user_already_exists=True, submit=True)

		if User.query.filter_by(email = email).first():
			return serve_template("register.html" \
			, user_email_exists=True, submit=True)        
		authkey = userinfo.generate_auth_key()
		password = userinfo.md5pass(password1)
		# Clean the password fields - security
		password1 = None
		password2 = None
		# Insert the new user
		new_user = User(\
			username = name, \
			email = email, \
			password = password, \
			authkey = authkey, \
			auth = 0, \
			t_register = datetime.now(), \
			t_login = datetime.now(), \
			t_seen = datetime.now() )
		session.commit()
		sender = get_template_def(\
			"register.html", "sender_email").strip()
		send_mail(template_name = "register.mail" \
			, sender = sender \
			, destination = email \
			, username = name \
			, authkey = authkey \
			, sitename = "localhost" \
			)
		return serve_template("register.html", submit=True)


cherrypy.root.register = Register_View()
